/******************************************************************************
*
*  DSPIVT.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.module/ABS=0                               modDSPIVT;

#include ".\comsys\hdr\comhdr.h"
#include ".\gen_fx\hdr\GenFX.h"

VectorTable:
    cntr=0x3fff;
    do POD until CE;
POD:  nop;
    jump main;                              /* reset */
    
    rti; rti; rti; rti;                     /* IRQ2 */
    rti; rti; rti; rti;                     /* IRQL1 */
    rti; rti; rti; rti;                     /* IRQL0 */
    
    jump TX0ISR;
         rti; rti; rti;                     /* SPORT0 tx */
    jump GetSamples;
         rti; rti; rti;                     /* SPORT0 rx */
    
    jump GetRandomVal;
         rti; rti; rti;                     /* IRQE */
    
    rti; rti; rti; rti;                     /* BDMA */
    
    rti; rti; rti; rti;                     /* SPORT1 tx or IRQ1 */
    rti; rti; rti; rti;                     /* SPORT1 rx or IRQ0 */
    rti; rti; rti; rti;                     /* timer */
    rti; rti; rti; rti;                     /* power down */
  
.ENDMOD;
