/******************************************************************************
*
*  ReRandomize.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modReRandomize;

/*
 *  include files for all functions
 */

#include    ".\comsys\hdr\comhdr.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      ReRandomize;

ReRandomize:
    M5 = 3;
    AY1 = 0x7fff;

/*
 *  randomize a_RandLUT, runs at krate.  watch out for 0x0000, 0x7fff, 0x8001,
 *  0x8000 to make life easier.  use xor for randomization.
 */
    
    CNTR = 171;
    do ReR until CE;
      AR = DM(I6, M5);
      AY0 = DM(I6, M6);
      AR = AR xor AY0;
      if EQ AR = AR + 128;                  /* check for 0x0000 */
      NONE = AR - AY1;
      if EQ AR = AR - 256;                  /* check for 0x7fff */
      NONE = AR + AY1;
      if EQ AR = AR + 1024;                 /* check for 0x8001 */
      AF = AR - 0x8000;
      if EQ AR = AR + 2048;                 /* check for 0x8000 */
ReR:  DM(I6, M6) = AR;

    rts;

.ENDMOD;    