/******************************************************************************
*
*  DSPDefs.h
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

#define     IDMA_CONTROL                    0x3fe0
#define     BDMA_BIAD                       0x3fe1
#define     BDMA_BEAD                       0x3fe2
#define     BDMA_CONTROL                    0x3fe3
#define     BDMA_BWCOUNT                    0x3fe4
#define     PROG_FLAG_DATA                  0x3fe5
#define     PROG_FLAG_DIR                   0x3fe6
                                            
#define     SPORT1_AUTOBUF                  0x3fef
#define     SPORT1_RFSDIV                   0x3ff0
#define     SPORT1_SCLKDIV                  0x3ff1
#define     SPORT1_CONTROL                  0x3ff2

#define     SPORT0_AUTOBUF                  0x3ff3
#define     SPORT0_RFSDIV                   0x3ff4
#define     SPORT0_SCLKDIV                  0x3ff5
#define     SPORT0_CONTROL                  0x3ff6
                                            
#define     SPORT0_TX_CHANNELS0             0x3ff7
#define     SPORT0_TX_CHANNELS1             0x3ff8
#define     SPORT0_RX_CHANNELS0             0x3ff9
#define     SPORT0_RX_CHANNELS1             0x3ffa
                                            
#define     TSCALE                          0x3ffb
#define     TCOUNT                          0x3ffc
#define     TPERIOD                         0x3ffd
                                            
#define     WAIT_STATE                      0x3ffe
#define     SYSTEM_CONTROL                  0x3fff
                                            
#define     TIMER_IRQ                       0x0001
#define     SPORT1RX_IRQ                    0x0002
#define     SPORT1TX_IRQ                    0x0004
#define     BDMA_IRQ                        0x0008
#define     IRQE_IRQ                        0x0010
#define     SPORT0RX_IRQ                    0x0020
#define     SPORT0TX_IRQ                    0x0040
#define     IRQL0_IRQ                       0x0080
#define     IRQL1_IRQ                       0x0100
#define     IRQ2_IRQ                        0x0200
                                            
#define     SPORT0_ENABLE                   12
#define     SPORT1_ENABLE                   11
                                            
/* serial port constants */                                 
#define     SERIAL_16BITS                   15
#define     SERIAL_12BITS                   11
#define     SERIAL_8BITS                    7
                                            
#define     ENABLE_MULTICHANNEL             0x8000
#define     DISABLE_MULTICHANNEL            0x0000
#define     INTERNAL_SCLK                   0x4000
#define     FRAME_DELAY1                    0x0400
#define     TDM_32_CHANNELS                 0x0200
#define     TDM_24_CHANNELS                 0x0000
#define     RFS_INTERNAL                    0x0100
#define     RFS_EXTERNAL                    0x0000
#define     TFS_ACTIVE_LOW                  0x0080
#define     TFS_ACTIVE_HIGH                 0x0000
#define     RFS_ACTIVE_LOW                  0x0040
#define     RFS_ACTIVE_HIGH                 0x0000
#define     RIGHT_JUSTIFY_ZERO_FILL         0x0000
#define     RIGHT_JUSTIFY_SIGNED            0x0010
#define     ULAW_COMPANDING                 0x0020
#define     ALAW_COMPANDING                 0x0030
                                            
#define     RX_AUTOBUF                      0x0001
#define     TX_AUTOBUF                      0x0002
#define     RX_MREG_M0                      0x0000
#define     RX_MREG_M1                      0x0004
#define     RX_IREG_I0                      0x0000
#define     TX_MREG_M0                      0x0000
#define     TX_MREG_M1                      0x0080
#define     TX_MREG_M2                      0x0100
#define     TX_IREG_I0                      0x0000
#define     TX_IREG_I1                      0x0200
#define     ENA_MAC_BIASRND                 0x1000
#define     DIS_MAC_BIASRND                 0x0000
#define     ENA_CLKOUT                      0x4000
#define     DIS_CLKOUT                      0x0000
                                            
#define     TX_ENA_CHANNEL1_16              0xffff
#define     TX_ENA_CHANNEL17_32             0xffff
#define     RX_ENA_CHANNEL1_16              0xffff
#define     RX_ENA_CHANNEL17_32             0xffff