/******************************************************************************
*
*  ReadAudioIn.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     mod_GetAudioIn;

/*
 *  include files
 */



#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"


/*
 *  external variables
 */

.ENTRY      ReadLeftInput;
.ENTRY      ReadRightInput;
.ENTRY      ReadBothMixedInputs;

ReadLeftInput:
    I2 = DM(p_LOutAudioInBuff);
    L2 = 128;
    AR = DM(I2, M1);
    DM(p_LOutAudioInBuff) = I2;
    L2 = 0;
    DM(I7, M6) = AR;
    rts;
    
ReadRightInput:
    I2 = DM(p_ROutAudioInBuff);
    
    L2 = 128;
    AR = DM(I2, M1);
    DM(p_ROutAudioInBuff) = I2;
    L2 = 0;
    DM(I7, M6) = AR;
    rts;
    
ReadBothMixedInputs:
    I2 = DM(p_ROutAudioInBuff);
    L2 = 128;
    SR0 = DM(I2, M1);
    DM(p_ROutAudioInBuff) = I2;
    
    I2 = DM(p_LOutAudioInBuff);
    SE = -1;
    !L2 = 128;
    SR=ashift SR0 (LO), AR=DM(I2,M1);
    DM(p_LOutAudioInBuff) = I2;
    L2 = 0;
    AY0=SR0, SR=ashift AR (LO);
    AR = SR0 + AY0;
    DM(I7, M6) = AR;
    rts;

.ENDMOD;
