/*
 *  GenFX functions and associated vars
 */

#ifndef     GENFXVAR_FUNC
#ifndef     SONGVAR_FUNC

/* envelopes of various types */
.EXTERNAL   a_ADSRPanEnv;
.EXTERNAL   p_ADSRPanEnv;
.EXTERNAL   ADSRPanEnv;
.EXTERNAL   a_ExpDecayEnv;
.EXTERNAL   p_ExpDecayEnv;
.EXTERNAL   ExpDecayEnv;

/* signal generators */
.EXTERNAL   a_AlgoSineGen;
.EXTERNAL   p_AlgoSineGen;
.EXTERNAL   AlgoSineGen;
.EXTERNAL   a_AlgoSineSatGen;
.EXTERNAL   p_AlgoSineSatGen;
.EXTERNAL   AlgoSineSatGen;
.EXTERNAL   a_PerNoiseGen;
.EXTERNAL   p_PerNoiseGen;
.EXTERNAL   PerNoiseGen;
.EXTERNAL   a_WTGen;
.EXTERNAL   p_WTGen;
.EXTERNAL   WTGen;
.EXTERNAL   p_WTGen2;
.EXTERNAL   a_WTGen2;
.EXTERNAL   WTGen2;
.EXTERNAL   p_HPWTGen2;
.EXTERNAL   a_HPWTGen2;
.EXTERNAL   HPWTGen2;
.EXTERNAL   a_KSGen;
.EXTERNAL   p_KSGen;
.EXTERNAL   KSGen;
.EXTERNAL   a_ProbKSGen;
.EXTERNAL   p_ProbKSGen;
.EXTERNAL   ProbKSGen;
.EXTERNAL   a_OscCombGen;
.EXTERNAL   p_OscCombGen;
.EXTERNAL   OscCombGen;
.EXTERNAL   a_Exp1Gen;
.EXTERNAL   p_Exp1Gen;
.EXTERNAL   Exp1Gen;
.EXTERNAL   a_DelaySynthGen;
.EXTERNAL   p_DelaySynthGen;
.EXTERNAL   DelaySynthGen;
.EXTERNAL   a_TunedRotSynthGen;
.EXTERNAL   p_TunedRotSynthGen;
.EXTERNAL   TunedRotSynthGen;
.EXTERNAL   a_RotSynthGen;
.EXTERNAL   p_RotSynthGen;
.EXTERNAL   RotSynthGen;
.EXTERNAL   a_ProbSynthGen;
.EXTERNAL   p_ProbSynthGen;
.EXTERNAL   ProbSynthGen;
.EXTERNAL   a_ProbSynthGenMask;
.EXTERNAL   a_FM2Op0Gen;
.EXTERNAL   p_FM2Op0Gen;
.EXTERNAL   FM2Op0Gen;
.EXTERNAL   a_MultiGen;
.EXTERNAL   p_MultiGen;
.EXTERNAL   MultiGen;
.EXTERNAL   a_ExpImpulseGen;
.EXTERNAL   p_ExpImpulseGen;
.EXTERNAL   ExpImpulseGen;
.EXTERNAL   a_CopiedGen;
.EXTERNAL   p_CopiedGen;
.EXTERNAL   CopiedGen;
.EXTERNAL   ReadLeftInput;
.EXTERNAL   ReadRightInput;
.EXTERNAL   ReadBothMixedInputs;

.EXTERNAL   v_LSWSeed;
.EXTERNAL   v_MSWSeed;

/* useful buffers and LUTs */
.EXTERNAL   a_RandLUT;
.EXTERNAL   a_KSBuff0;
.EXTERNAL   a_KSBuff1;
.EXTERNAL   a_KSBuff2;
.EXTERNAL   a_KSBuff3;
.EXTERNAL   a_KSBuff4;
.EXTERNAL   a_KSBuff5;
.EXTERNAL   a_KSBuff6;
.EXTERNAL   a_KSBuff7;
.EXTERNAL   a_DelayBuff0;
.EXTERNAL   a_DelayBuff1;
.EXTERNAL   a_MIDIFreq;
.EXTERNAL   a_MIDIFreqKS;
.EXTERNAL   a_PerNoiseGenParam;
.EXTERNAL   a_WTSine;
.EXTERNAL   a_WTSq;
.EXTERNAL   a_WTTri;
.EXTERNAL   a_WTSaw;
.EXTERNAL   a_TrigTrack00;
.EXTERNAL   a_TrigTrack01;
.EXTERNAL   a_TrigTrack02;
.EXTERNAL   a_TrigTrack03;
.EXTERNAL   a_TrigTrack04;
.EXTERNAL   a_TrigTrack05;
.EXTERNAL   a_TrigTrack06;
.EXTERNAL   a_TrigTrack07;
.EXTERNAL   a_TrigTrack08;
.EXTERNAL   a_TrigTrack09;
.EXTERNAL   a_TrigTrack10;
.EXTERNAL   a_TrigTrack11;
.EXTERNAL   a_TrigTrack12;
.EXTERNAL   a_TrigTrack13;
.EXTERNAL   a_TrigTrack14;
.EXTERNAL   a_TrigTrack15;
.EXTERNAL   a_TrigTrack16;
.EXTERNAL   a_TrigTrack17;
.EXTERNAL   a_TrigTrack18;
.EXTERNAL   a_TrigTrack19;
.EXTERNAL   a_TrigTrack20;
.EXTERNAL   a_TrigTrack21;
.EXTERNAL   a_TrigTrack22;
.EXTERNAL   a_TrigTrack23;
.EXTERNAL   a_TrigTrack24;
.EXTERNAL   a_TrigTrack25;
.EXTERNAL   a_TrigTrack26;
.EXTERNAL   a_TrigTrack27;
.EXTERNAL   a_TrigTrack28;
.EXTERNAL   a_TrigTrack29;
.EXTERNAL   a_TrigTrack30;
.EXTERNAL   a_TrigTrack31;
.EXTERNAL   a_VolTrack00;
.EXTERNAL   a_VolTrack01;
.EXTERNAL   a_VolTrack02;
.EXTERNAL   a_VolTrack03;
.EXTERNAL   a_VolTrack04;
.EXTERNAL   a_VolTrack05;
.EXTERNAL   a_VolTrack06;
.EXTERNAL   a_VolTrack07;
.EXTERNAL   a_VolTrack08;
.EXTERNAL   a_VolTrack09;
.EXTERNAL   a_VolTrack10;
.EXTERNAL   a_VolTrack11;
.EXTERNAL   a_VolTrack12;
.EXTERNAL   a_VolTrack13;
.EXTERNAL   a_VolTrack14;
.EXTERNAL   a_VolTrack15;
.EXTERNAL   a_VolTrack16;
.EXTERNAL   a_VolTrack17;
.EXTERNAL   a_VolTrack18;
.EXTERNAL   a_VolTrack19;
.EXTERNAL   a_VolTrack20;
.EXTERNAL   a_VolTrack21;
.EXTERNAL   a_VolTrack22;
.EXTERNAL   a_VolTrack23;
.EXTERNAL   a_VolTrack24;
.EXTERNAL   a_VolTrack25;
.EXTERNAL   a_VolTrack26;
.EXTERNAL   a_VolTrack27;
.EXTERNAL   a_VolTrack28;
.EXTERNAL   a_VolTrack29;
.EXTERNAL   a_VolTrack30;
.EXTERNAL   a_VolTrack31;
.EXTERNAL   ap_CTRLTrack00;
.EXTERNAL   a_CTRLTrack00_0;
.EXTERNAL   a_CTRLTrack00_1;
.EXTERNAL   a_CTRLTrack00_2;
.EXTERNAL   a_CTRLTrack00_3;
.EXTERNAL   a_CTRLTrack00_4;
.EXTERNAL   a_CTRLTrack00_5;
.EXTERNAL   a_CTRLTrack00_6;
.EXTERNAL   a_CTRLTrack00_7;
.EXTERNAL   ap_CTRLTrack01;
.EXTERNAL   a_CTRLTrack01_0;
.EXTERNAL   a_CTRLTrack01_1;
.EXTERNAL   a_CTRLTrack01_2;
.EXTERNAL   a_CTRLTrack01_3;
.EXTERNAL   a_CTRLTrack01_4;
.EXTERNAL   a_CTRLTrack01_5;
.EXTERNAL   a_CTRLTrack01_6;
.EXTERNAL   a_CTRLTrack01_7;
.EXTERNAL   ap_CTRLTrack02;
.EXTERNAL   a_CTRLTrack02_0;
.EXTERNAL   a_CTRLTrack02_1;
.EXTERNAL   a_CTRLTrack02_2;
.EXTERNAL   a_CTRLTrack02_3;
.EXTERNAL   a_CTRLTrack02_4;
.EXTERNAL   a_CTRLTrack02_5;
.EXTERNAL   a_CTRLTrack02_6;
.EXTERNAL   a_CTRLTrack02_7;
.EXTERNAL   ap_CTRLTrack03;
.EXTERNAL   a_CTRLTrack03_0;
.EXTERNAL   a_CTRLTrack03_1;
.EXTERNAL   a_CTRLTrack03_2;
.EXTERNAL   a_CTRLTrack03_3;
.EXTERNAL   a_CTRLTrack03_4;
.EXTERNAL   a_CTRLTrack03_5;
.EXTERNAL   a_CTRLTrack03_6;
.EXTERNAL   a_CTRLTrack03_7;
.EXTERNAL   ap_CTRLTrack04;
.EXTERNAL   a_CTRLTrack04_0;
.EXTERNAL   a_CTRLTrack04_1;
.EXTERNAL   a_CTRLTrack04_2;
.EXTERNAL   a_CTRLTrack04_3;
.EXTERNAL   a_CTRLTrack04_4;
.EXTERNAL   a_CTRLTrack04_5;
.EXTERNAL   a_CTRLTrack04_6;
.EXTERNAL   a_CTRLTrack04_7;
.EXTERNAL   ap_CTRLTrack05;
.EXTERNAL   a_CTRLTrack05_0;
.EXTERNAL   a_CTRLTrack05_1;
.EXTERNAL   a_CTRLTrack05_2;
.EXTERNAL   a_CTRLTrack05_3;
.EXTERNAL   a_CTRLTrack05_4;
.EXTERNAL   a_CTRLTrack05_5;
.EXTERNAL   a_CTRLTrack05_6;
.EXTERNAL   a_CTRLTrack05_7;
.EXTERNAL   ap_CTRLTrack06;
.EXTERNAL   a_CTRLTrack06_0;
.EXTERNAL   a_CTRLTrack06_1;
.EXTERNAL   a_CTRLTrack06_2;
.EXTERNAL   a_CTRLTrack06_3;
.EXTERNAL   a_CTRLTrack06_4;
.EXTERNAL   a_CTRLTrack06_5;
.EXTERNAL   a_CTRLTrack06_6;
.EXTERNAL   a_CTRLTrack06_7;
.EXTERNAL   ap_CTRLTrack07;
.EXTERNAL   a_CTRLTrack07_0;
.EXTERNAL   a_CTRLTrack07_1;
.EXTERNAL   a_CTRLTrack07_2;
.EXTERNAL   a_CTRLTrack07_3;
.EXTERNAL   a_CTRLTrack07_4;
.EXTERNAL   a_CTRLTrack07_5;
.EXTERNAL   a_CTRLTrack07_6;
.EXTERNAL   a_CTRLTrack07_7;
.EXTERNAL   ap_CTRLTrack08;
.EXTERNAL   a_CTRLTrack08_0;
.EXTERNAL   a_CTRLTrack08_1;
.EXTERNAL   a_CTRLTrack08_2;
.EXTERNAL   a_CTRLTrack08_3;
.EXTERNAL   a_CTRLTrack08_4;
.EXTERNAL   a_CTRLTrack08_5;
.EXTERNAL   a_CTRLTrack08_6;
.EXTERNAL   a_CTRLTrack08_7;
.EXTERNAL   ap_CTRLTrack09;
.EXTERNAL   a_CTRLTrack09_0;
.EXTERNAL   a_CTRLTrack09_1;
.EXTERNAL   a_CTRLTrack09_2;
.EXTERNAL   a_CTRLTrack09_3;
.EXTERNAL   a_CTRLTrack09_4;
.EXTERNAL   a_CTRLTrack09_5;
.EXTERNAL   a_CTRLTrack09_6;
.EXTERNAL   a_CTRLTrack09_7;
.EXTERNAL   ap_CTRLTrack10;
.EXTERNAL   a_CTRLTrack10_0;
.EXTERNAL   a_CTRLTrack10_1;
.EXTERNAL   a_CTRLTrack10_2;
.EXTERNAL   a_CTRLTrack10_3;
.EXTERNAL   a_CTRLTrack10_4;
.EXTERNAL   a_CTRLTrack10_5;
.EXTERNAL   a_CTRLTrack10_6;
.EXTERNAL   a_CTRLTrack10_7;
.EXTERNAL   ap_CTRLTrack11;
.EXTERNAL   a_CTRLTrack11_0;
.EXTERNAL   a_CTRLTrack11_1;
.EXTERNAL   a_CTRLTrack11_2;
.EXTERNAL   a_CTRLTrack11_3;
.EXTERNAL   a_CTRLTrack11_4;
.EXTERNAL   a_CTRLTrack11_5;
.EXTERNAL   a_CTRLTrack11_6;
.EXTERNAL   a_CTRLTrack11_7;
.EXTERNAL   ap_CTRLTrack12;
.EXTERNAL   a_CTRLTrack12_0;
.EXTERNAL   a_CTRLTrack12_1;
.EXTERNAL   a_CTRLTrack12_2;
.EXTERNAL   a_CTRLTrack12_3;
.EXTERNAL   a_CTRLTrack12_4;
.EXTERNAL   a_CTRLTrack12_5;
.EXTERNAL   a_CTRLTrack12_6;
.EXTERNAL   a_CTRLTrack12_7;
.EXTERNAL   ap_CTRLTrack13;
.EXTERNAL   a_CTRLTrack13_0;
.EXTERNAL   a_CTRLTrack13_1;
.EXTERNAL   a_CTRLTrack13_2;
.EXTERNAL   a_CTRLTrack13_3;
.EXTERNAL   a_CTRLTrack13_4;
.EXTERNAL   a_CTRLTrack13_5;
.EXTERNAL   a_CTRLTrack13_6;
.EXTERNAL   a_CTRLTrack13_7;
.EXTERNAL   ap_CTRLTrack14;
.EXTERNAL   a_CTRLTrack14_0;
.EXTERNAL   a_CTRLTrack14_1;
.EXTERNAL   a_CTRLTrack14_2;
.EXTERNAL   a_CTRLTrack14_3;
.EXTERNAL   a_CTRLTrack14_4;
.EXTERNAL   a_CTRLTrack14_5;
.EXTERNAL   a_CTRLTrack14_6;
.EXTERNAL   a_CTRLTrack14_7;
.EXTERNAL   ap_CTRLTrack15;
.EXTERNAL   a_CTRLTrack15_0;
.EXTERNAL   a_CTRLTrack15_1;
.EXTERNAL   a_CTRLTrack15_2;
.EXTERNAL   a_CTRLTrack15_3;
.EXTERNAL   a_CTRLTrack15_4;
.EXTERNAL   a_CTRLTrack15_5;
.EXTERNAL   a_CTRLTrack15_6;
.EXTERNAL   a_CTRLTrack15_7;
.EXTERNAL   ap_CTRLTrack16;
.EXTERNAL   a_CTRLTrack16_0;
.EXTERNAL   a_CTRLTrack16_1;
.EXTERNAL   a_CTRLTrack16_2;
.EXTERNAL   a_CTRLTrack16_3;
.EXTERNAL   a_CTRLTrack16_4;
.EXTERNAL   a_CTRLTrack16_5;
.EXTERNAL   a_CTRLTrack16_6;
.EXTERNAL   a_CTRLTrack16_7;
.EXTERNAL   ap_CTRLTrack17;
.EXTERNAL   a_CTRLTrack17_0;
.EXTERNAL   a_CTRLTrack17_1;
.EXTERNAL   a_CTRLTrack17_2;
.EXTERNAL   a_CTRLTrack17_3;
.EXTERNAL   a_CTRLTrack17_4;
.EXTERNAL   a_CTRLTrack17_5;
.EXTERNAL   a_CTRLTrack17_6;
.EXTERNAL   a_CTRLTrack17_7;
.EXTERNAL   ap_CTRLTrack18;
.EXTERNAL   a_CTRLTrack18_0;
.EXTERNAL   a_CTRLTrack18_1;
.EXTERNAL   a_CTRLTrack18_2;
.EXTERNAL   a_CTRLTrack18_3;
.EXTERNAL   a_CTRLTrack18_4;
.EXTERNAL   a_CTRLTrack18_5;
.EXTERNAL   a_CTRLTrack18_6;
.EXTERNAL   a_CTRLTrack18_7;
.EXTERNAL   ap_CTRLTrack19;
.EXTERNAL   a_CTRLTrack19_0;
.EXTERNAL   a_CTRLTrack19_1;
.EXTERNAL   a_CTRLTrack19_2;
.EXTERNAL   a_CTRLTrack19_3;
.EXTERNAL   a_CTRLTrack19_4;
.EXTERNAL   a_CTRLTrack19_5;
.EXTERNAL   a_CTRLTrack19_6;
.EXTERNAL   a_CTRLTrack19_7;
.EXTERNAL   ap_CTRLTrack20;
.EXTERNAL   a_CTRLTrack20_0;
.EXTERNAL   a_CTRLTrack20_1;
.EXTERNAL   a_CTRLTrack20_2;
.EXTERNAL   a_CTRLTrack20_3;
.EXTERNAL   a_CTRLTrack20_4;
.EXTERNAL   a_CTRLTrack20_5;
.EXTERNAL   a_CTRLTrack20_6;
.EXTERNAL   a_CTRLTrack20_7;
.EXTERNAL   ap_CTRLTrack21;
.EXTERNAL   a_CTRLTrack21_0;
.EXTERNAL   a_CTRLTrack21_1;
.EXTERNAL   a_CTRLTrack21_2;
.EXTERNAL   a_CTRLTrack21_3;
.EXTERNAL   a_CTRLTrack21_4;
.EXTERNAL   a_CTRLTrack21_5;
.EXTERNAL   a_CTRLTrack21_6;
.EXTERNAL   a_CTRLTrack21_7;
.EXTERNAL   ap_CTRLTrack22;
.EXTERNAL   a_CTRLTrack22_0;
.EXTERNAL   a_CTRLTrack22_1;
.EXTERNAL   a_CTRLTrack22_2;
.EXTERNAL   a_CTRLTrack22_3;
.EXTERNAL   a_CTRLTrack22_4;
.EXTERNAL   a_CTRLTrack22_5;
.EXTERNAL   a_CTRLTrack22_6;
.EXTERNAL   a_CTRLTrack22_7;
.EXTERNAL   ap_CTRLTrack23;
.EXTERNAL   a_CTRLTrack23_0;
.EXTERNAL   a_CTRLTrack23_1;
.EXTERNAL   a_CTRLTrack23_2;
.EXTERNAL   a_CTRLTrack23_3;
.EXTERNAL   a_CTRLTrack23_4;
.EXTERNAL   a_CTRLTrack23_5;
.EXTERNAL   a_CTRLTrack23_6;
.EXTERNAL   a_CTRLTrack23_7;
.EXTERNAL   ap_CTRLTrack24;
.EXTERNAL   a_CTRLTrack24_0;
.EXTERNAL   a_CTRLTrack24_1;
.EXTERNAL   a_CTRLTrack24_2;
.EXTERNAL   a_CTRLTrack24_3;
.EXTERNAL   a_CTRLTrack24_4;
.EXTERNAL   a_CTRLTrack24_5;
.EXTERNAL   a_CTRLTrack24_6;
.EXTERNAL   a_CTRLTrack24_7;
.EXTERNAL   ap_CTRLTrack25;
.EXTERNAL   a_CTRLTrack25_0;
.EXTERNAL   a_CTRLTrack25_1;
.EXTERNAL   a_CTRLTrack25_2;
.EXTERNAL   a_CTRLTrack25_3;
.EXTERNAL   a_CTRLTrack25_4;
.EXTERNAL   a_CTRLTrack25_5;
.EXTERNAL   a_CTRLTrack25_6;
.EXTERNAL   a_CTRLTrack25_7;
.EXTERNAL   ap_CTRLTrack26;
.EXTERNAL   a_CTRLTrack26_0;
.EXTERNAL   a_CTRLTrack26_1;
.EXTERNAL   a_CTRLTrack26_2;
.EXTERNAL   a_CTRLTrack26_3;
.EXTERNAL   a_CTRLTrack26_4;
.EXTERNAL   a_CTRLTrack26_5;
.EXTERNAL   a_CTRLTrack26_6;
.EXTERNAL   a_CTRLTrack26_7;
.EXTERNAL   ap_CTRLTrack27;
.EXTERNAL   a_CTRLTrack27_0;
.EXTERNAL   a_CTRLTrack27_1;
.EXTERNAL   a_CTRLTrack27_2;
.EXTERNAL   a_CTRLTrack27_3;
.EXTERNAL   a_CTRLTrack27_4;
.EXTERNAL   a_CTRLTrack27_5;
.EXTERNAL   a_CTRLTrack27_6;
.EXTERNAL   a_CTRLTrack27_7;
.EXTERNAL   ap_CTRLTrack28;
.EXTERNAL   a_CTRLTrack28_0;
.EXTERNAL   a_CTRLTrack28_1;
.EXTERNAL   a_CTRLTrack28_2;
.EXTERNAL   a_CTRLTrack28_3;
.EXTERNAL   a_CTRLTrack28_4;
.EXTERNAL   a_CTRLTrack28_5;
.EXTERNAL   a_CTRLTrack28_6;
.EXTERNAL   a_CTRLTrack28_7;
.EXTERNAL   ap_CTRLTrack29;
.EXTERNAL   a_CTRLTrack29_0;
.EXTERNAL   a_CTRLTrack29_1;
.EXTERNAL   a_CTRLTrack29_2;
.EXTERNAL   a_CTRLTrack29_3;
.EXTERNAL   a_CTRLTrack29_4;
.EXTERNAL   a_CTRLTrack29_5;
.EXTERNAL   a_CTRLTrack29_6;
.EXTERNAL   a_CTRLTrack29_7;
.EXTERNAL   ap_CTRLTrack30;
.EXTERNAL   a_CTRLTrack30_0;
.EXTERNAL   a_CTRLTrack30_1;
.EXTERNAL   a_CTRLTrack30_2;
.EXTERNAL   a_CTRLTrack30_3;
.EXTERNAL   a_CTRLTrack30_4;
.EXTERNAL   a_CTRLTrack30_5;
.EXTERNAL   a_CTRLTrack30_6;
.EXTERNAL   a_CTRLTrack30_7;
.EXTERNAL   ap_CTRLTrack31;
.EXTERNAL   a_CTRLTrack31_0;
.EXTERNAL   a_CTRLTrack31_1;
.EXTERNAL   a_CTRLTrack31_2;
.EXTERNAL   a_CTRLTrack31_3;
.EXTERNAL   a_CTRLTrack31_4;
.EXTERNAL   a_CTRLTrack31_5;
.EXTERNAL   a_CTRLTrack31_6;
.EXTERNAL   a_CTRLTrack31_7;
.EXTERNAL   a_CTRLData;
.EXTERNAL   p_CTRLData;


/* system buffers and externals - use with caution! */
.EXTERNAL   a_GenData;
.EXTERNAL   p_GenData;
.EXTERNAL   a_RSampOut;
.EXTERNAL   a_LSampOut;
.EXTERNAL   a_LOutBuff0;
.EXTERNAL   a_LOutBuff1;
.EXTERNAL   a_ROutBuff0;
.EXTERNAL   a_ROutBuff1;
.EXTERNAL   p_LBuffToTX;
.EXTERNAL   p_RBuffToTX;
.EXTERNAL   a_GenFXPtrInits;
.EXTERNAL   p_GenFXPtrInits;
.EXTERNAL   b_EndSong;
.EXTERNAL   a_LAudioInBuff;
.EXTERNAL   p_LInAudioInBuff;
.EXTERNAL   p_LOutAudioInBuff;
.EXTERNAL   a_RAudioInBuff;
.EXTERNAL   p_RInAudioInBuff;
.EXTERNAL   p_ROutAudioInBuff;
.EXTERNAL   a_MixScalars;

/* memory modifiers */
.EXTERNAL   a_LFO;
.EXTERNAL   p_LFO;
.EXTERNAL   LFO3;
.EXTERNAL   v_NumLFO3;
.EXTERNAL   a_MemEnv3;
.EXTERNAL   p_MemEnv3;
.EXTERNAL   MemEnv3;
.EXTERNAL   v_NumMemEnv3;
.EXTERNAL   a_MemEnv1;
.EXTERNAL   p_MemEnv1;
.EXTERNAL   MemEnv1;
.EXTERNAL   v_NumMemEnv1;
.EXTERNAL   a_MemEnv2;
.EXTERNAL   p_MemEnv2;
.EXTERNAL   MemEnv2;
.EXTERNAL   v_NumMemEnv2;
.EXTERNAL   a_VolEnv;
.EXTERNAL   p_VolEnv;
.EXTERNAL   VolEnv;

/* fx */
.EXTERNAL   a_ClampFX;
.EXTERNAL   p_ClampFX;
.EXTERNAL   ClampFX;
.EXTERNAL   a_ZeroSampsFX;
.EXTERNAL   p_ZeroSampsFX;
.EXTERNAL   ZeroSampsFX;
.EXTERNAL   a_SVFFX;
.EXTERNAL   p_SVFFX;
.EXTERNAL   a_SVFFiltOut;
.EXTERNAL   p_SVFFiltOut;
.EXTERNAL   SVFFX;
.EXTERNAL   a_PrevCurrFiltFX;
.EXTERNAL   p_PrevCurrFiltFX;
.EXTERNAL   PrevCurrFiltFX;
.EXTERNAL   a_KillTimeFX;
.EXTERNAL   p_KillTimeFX;
.EXTERNAL   KillTimeFX;
.EXTERNAL   a_RectifyFX;
.EXTERNAL   p_RectifyFX;
.EXTERNAL   RectifyFX;
.EXTERNAL   a_BitMaskFX;
.EXTERNAL   p_BitMaskFX;
.EXTERNAL   BitmaskFX;
.EXTERNAL   a_GenSHFX;
.EXTERNAL   p_GenSHFX;
.EXTERNAL   GenSHFX;
.EXTERNAL   a_WTGenSyncFX;
.EXTERNAL   p_WTGenSyncFX;
.EXTERNAL   WTGenSyncFX;
.EXTERNAL   a_WaveShapeFX;
.EXTERNAL   p_WaveShapeFX;
.EXTERNAL   WaveShapeFX;

/* init/utility funcs */
.EXTERNAL   FillKS0Buff;
.EXTERNAL   FillKS1Buff;
.EXTERNAL   FillKS2Buff;
.EXTERNAL   FillKS3Buff;
.EXTERNAL   FillKS4Buff;
.EXTERNAL   FillKS5Buff;
.EXTERNAL   FillKS6Buff;
.EXTERNAL   FillKS7Buff;
.EXTERNAL   FillDB0;
.EXTERNAL   FillDB1;
.EXTERNAL   FillKS_JT;
.EXTERNAL   DummyRet;
.EXTERNAL   a_EnvTypes;
.EXTERNAL   GenFXIniPostProc;
.EXTERNAL   Seq2PostProc;
.EXTERNAL   FillGenFXPtrInits;
.EXTERNAL   USDivideNoRem;
.EXTERNAL   FRL;

/* misc vars */
.EXTERNAL   v_CurrSong;
.EXTERNAL   InitGMParamsPtr;
.EXTERNAL   GenFXPtr;
.EXTERNAL   SetFABCNTRPtr;
.EXTERNAL   ModFuncsPtr;
.EXTERNAL   MixerProcPtr;
.EXTERNAL   EnvProcPtr;
.EXTERNAL   v_NumSongs;
.EXTERNAL   v_Dummy;
.EXTERNAL   p_Vol;
.EXTERNAL   v_TrigOffset;
.EXTERNAL   v_CurrMeasure;
.EXTERNAL   v_TicsPerMeasure;
.EXTERNAL   v_TicCNTR;
.EXTERNAL   v_MeasuresPerSong;
.EXTERNAL   EndMeasure_JT;
.EXTERNAL   Measure_JT;
.EXTERNAL   b_NextSong;
.EXTERNAL   v_LChanOut;
.EXTERNAL   v_RChanOut;
.EXTERNAL   LBasicMix;
.EXTERNAL   RBasicMix;
.EXTERNAL   p_LOutBuff;
.EXTERNAL   p_ROutBuff;

.EXTERNAL   FRL;

.EXTERNAL   a_Seq;
.EXTERNAL   Seq2;
.EXTERNAL   a_TrackTriggered;

.EXTERNAL   InitTrack00;
.EXTERNAL   InitTrack01;
.EXTERNAL   InitTrack02;
.EXTERNAL   InitTrack03;
.EXTERNAL   InitTrack04;
.EXTERNAL   InitTrack05;
.EXTERNAL   InitTrack06;
.EXTERNAL   InitTrack07;
.EXTERNAL   InitTrack08;
.EXTERNAL   InitTrack09;
.EXTERNAL   InitTrack10;
.EXTERNAL   InitTrack11;
.EXTERNAL   InitTrack12;
.EXTERNAL   InitTrack13;
.EXTERNAL   InitTrack14;
.EXTERNAL   InitTrack15;
.EXTERNAL   InitTrack16;
.EXTERNAL   InitTrack17;
.EXTERNAL   InitTrack18;
.EXTERNAL   InitTrack19;
.EXTERNAL   InitTrack20;
.EXTERNAL   InitTrack21;
.EXTERNAL   InitTrack22;
.EXTERNAL   InitTrack23;
.EXTERNAL   InitTrack24;
.EXTERNAL   InitTrack25;
.EXTERNAL   InitTrack26;
.EXTERNAL   InitTrack27;
.EXTERNAL   InitTrack28;
.EXTERNAL   InitTrack29;
.EXTERNAL   InitTrack30;
.EXTERNAL   InitTrack31;

#endif
#endif
