/******************************************************************************
*
*  templatevars.h
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  place all newly created project-specific variables and functions here.  this
*  would include variables that might be needed in song control and functions
*  that are called by the sequencer during initialization (those in
*  TrigInit.dsp).
*
******************************************************************************/

#ifndef SONGVAR_FUNC

/*
 *  place .EXTERNAL declarations in here to avoid compilation errors
 */

.EXTERNAL   a_LeadNotes;
.EXTERNAL   p_LeadNotes0;
.EXTERNAL   p_LeadNotes1;
.EXTERNAL   a_PadNotes;

.EXTERNAL   v_KeepLeadFreq0;
.EXTERNAL   v_KeepLeadFreq1;
.EXTERNAL   v_IncLeadFreq0;
.EXTERNAL   v_IncLeadFreq1;
.EXTERNAL   v_DecLeadFreq0;
.EXTERNAL   v_DecLeadFreq1;

.EXTERNAL   v_PadMask;

.EXTERNAL   v_NoiseFiltFreq;
.EXTERNAL   v_LowOrHighBassNote;

.EXTERNAL   v_ProbLowGenSHFX;

#endif