/******************************************************************************
*
*  TrigInit.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  functions called when track is retriggered.  pointers to these functions are
*  placed in the a_Seq array.
*
******************************************************************************/

.MODULE                                     modTrigInit_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "songnow.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitTrack00;
.ENTRY      InitTrack01;
.ENTRY      InitTrack02;
.ENTRY      InitTrack03;
.ENTRY      InitTrack04;
.ENTRY      InitTrack05;
.ENTRY      InitTrack06;
.ENTRY      InitTrack07;
.ENTRY      InitTrack08;
.ENTRY      InitTrack09;
.ENTRY      InitTrack10;
.ENTRY      InitTrack11;
.ENTRY      InitTrack12;
.ENTRY      InitTrack13;
.ENTRY      InitTrack14;
.ENTRY      InitTrack15;
.ENTRY      InitTrack16;
.ENTRY      InitTrack17;
.ENTRY      InitTrack18;
.ENTRY      InitTrack19;
.ENTRY      InitTrack20;
.ENTRY      InitTrack21;
.ENTRY      InitTrack22;
.ENTRY      InitTrack23;
.ENTRY      InitTrack24;
.ENTRY      InitTrack25;
.ENTRY      InitTrack26;
.ENTRY      InitTrack27;
.ENTRY      InitTrack28;
.ENTRY      InitTrack29;
.ENTRY      InitTrack30;
.ENTRY      InitTrack31;

InitTrack00:
    RESET_MEMENV2(0);
    RESET_PHASE_WTGEN2(0);
    rts;
    
InitTrack01:
    RESET_KSGEN(0);
    RESET_KSGEN(1);
    
    AR = DM(v_CurrGenKSSH);
    AR = AR + 1;
    AY0 = 12+24;
    DM(a_MemEnv3+(2*MEMENV3_VARS)+MEMENV3_ATIME) = AR;
    DM(a_MemEnv3+(3*MEMENV3_VARS)+MEMENV3_ATIME) = AR;
    DM(v_CurrGenKSSH) = AR;
    NONE = AR - AY0;
    if LE jump MEReset;
    AR = 12;
    DM(v_CurrGenKSSH) = AR;

MEReset:    
    RESET_MEMENV3(2);
    RESET_MEMENV3(3);
    
    rts;
    
InitTrack02:    
    rts;
    
InitTrack03:
    RESET_KSGEN(2);
    RESET_KSGEN(3);
        
    rts;
    
InitTrack04:
    rts;
    
InitTrack05:
    RESET_KSGEN(4);
    RESET_KSGEN(5);
    RESET_MEMENV3(0);
    RESET_MEMENV3(1);
    rts;
    
InitTrack06:
    rts;
    
InitTrack07:
    RESET_MEMENV3(12);
    RESET_FM2OP0GEN(0);
    rts;
    
InitTrack08:
    RESET_MEMENV3(13);
    RESET_FM2OP0GEN(1);
    rts;
    
InitTrack09:
    RESET_FM2OP0GEN(2);
    rts;
    
InitTrack10:
    RESET_FM2OP0GEN(3);
    rts;
    
InitTrack11:
    RESET_FM2OP0GEN(4);
    rts;
    
InitTrack12:
    AR = DM(v_IncFMFreq);
    AR = pass AR;
    if EQ rts;
    
    AR = DM(v_CurrFreqFM0);
    AR = AR + 1;
    DM(a_WTGen2+(1*WTGEN2_VARS)+WTGEN2_FREQ) = AR;
    DM(v_CurrFreqFM0) = AR;
    AY0 = 407;
    NONE = AR - AY0;
    if LE rts;
    AR = 400;
    DM(v_CurrFreqFM0) = AR;
    rts;
    
InitTrack13:
    AR = DM(v_IncFMFreq);
    AR = pass AR;
    if EQ rts;
    
    AR = DM(v_CurrFreqFM1);
    AR = AR + 1;
    DM(a_WTGen2+(2*WTGEN2_VARS)+WTGEN2_FREQ) = AR;
    DM(v_CurrFreqFM1) = AR;
    AY0 = 605;
    NONE = AR - AY0;
    if LE rts;
    AR = 600;
    DM(v_CurrFreqFM1) = AR;
    rts;
    
InitTrack14:
/*
    I2 = DM(p_LeadNotes0);
    L2 = %a_LeadNotes0;
    AR = DM(I2, M1);
    DM(p_LeadNotes0) = I2;
    L2 = 0;
    DM(a_WTGen2+(3*WTGEN2_VARS)+WTGEN2_FREQ) = AR;
    !AR = AR + 1;
    DM(a_WTGen2+(4*WTGEN2_VARS)+WTGEN2_FREQ) = AR;
*/  
    rts;
    
InitTrack15:
    rts;
    
InitTrack16:
    rts;
    
InitTrack17:
    rts;
    
InitTrack18:
    rts;
    
InitTrack19:
    rts;
    
InitTrack20:
    rts;
    
InitTrack21:
    rts;
    
InitTrack22:
    rts;
    
InitTrack23:
    rts;
    
InitTrack24:
    rts;
    
InitTrack25:
    rts;
    
InitTrack26:
    rts;
    
InitTrack27:
    rts;
    
InitTrack28:
    rts;
    
InitTrack29:
    rts;
    
InitTrack30:
    rts;
    
InitTrack31:
    rts;


.ENDMOD;
