/*******************************************************************************
*
*  GetRandomSeed.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

.MODULE                                     modGetRandSeed;

/*
 *  include files
 */

#include ".\comsys\hdr\comhdr.h"
#include ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      GetRandSeed;

GetRandSeed:
    /* set up timer to generate "random" seed.  wait to fill random buff. */
    AR = 0xffff;
    DM(TPERIOD) = AR;
    DM(TCOUNT) = AR;
    DM(TSCALE) = M0;
    ena TIMER;

W1: AR = DM(b_SeedCaptured);
    AR = pass AR;
    if EQ jump W1;
    
    rts;

.ENDMOD;
