/******************************************************************************
*
*  USDivide.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*  unsigned divide.  when called assumes the following parameters are init'ed:
*
*      AY1 | AY0
*      --------- = AR      rem = SR0
*         AX0
*
*  M_MODE (int multiplies) must be enabled on function call
*
******************************************************************************/

.MODULE                                     modUSDivide;

/*
 *  include files
 */
 
#include    ".\comsys\hdr\comhdr.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */
 
.ENTRY      USDivide;

USDivide:
    ASTAT = 0x0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;
    divq AX0;

CalcRem:
    MY0 = AX0, AR = pass AY0;
    ena M_MODE;
    MR = MR - AR*MY0 (uu);
    dis M_MODE;

    rts;
    
.ENDMOD;
