/******************************************************************************
*
*  MultiGen.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modMultiGen;


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

.VAR        saveI2;
.VAR        tempAcc;

.ENTRY      MultiGen;

MultiGen:
    I2 = DM(p_MultiGen);
    AR = DM(I2, M1);
    CNTR = AR;
    DM(tempAcc) = M0;
    do MG1 until CE;
      AR = DM(I2, M1);
      I5 = AR;
      DM(saveI2) = I2;
      call (I5);
      I2 = DM(saveI2);
      AR = DM(I2, M1);
      MY0 = DM(I7, M6);
      MR = AR * MY0 (RND);
      AY0 = DM(tempAcc);
      AR = MR1 + AY0;
MG1:  DM(tempAcc) = AR;

    DM(I7, M6) = AR;
    
    DM(p_MultiGen) = I2;
    rts;
    
.ENDMOD;
